diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java b/src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java
similarity index 82%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
rename to src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java
index 92f72557d..eae86b8ac 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java
@@ -1,136 +1,136 @@
-package net.minecraft.core.entity.projectile;
-
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.util.helper.Axis;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3d;
-import net.minecraft.core.world.World;
-
-import java.util.List;
-
-public class EntityCannonballBouncy extends EntityCannonball
-{
-    private int fuse = 50;
-
-    public EntityCannonballBouncy(World world, double x, double y, double z)
-    {
-        super(world, x, y, z);
-        this.defaultGravity = 0.06f;
-    }
-
-    public EntityCannonballBouncy(World world, EntityLiving owner)
-    {
-        super(world, owner);
-        x += xd;
-        y += yd;
-        z += zd;
-        setHeading(xd, yd, zd, 0.75F, 0.0F);
-        this.defaultGravity = 0.06f;
-    }
-
-    @Override
-    public void tick()
-    {
-        baseTick();
-        if(xRotO == 0.0F && yRotO == 0.0F)
-        {
-            float f = MathHelper.sqrt_double(xd * xd + zd * zd);
-            yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-            xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
-        }
-
-        float velocity = MathHelper.sqrt_double(xd * xd + yd * yd + zd * zd);
-
-        // Check for block collision
-        Vec3d currentPos = Vec3d.createVector(x, y, z);
-        Vec3d nextPos = Vec3d.createVector(x + xd, y + yd - 0.25f, z + zd);
-        HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true);
-        if(hit != null)
-        {
-            if (hit.hitType == HitResult.HitType.TILE)
-            {
-                float bounceAxisScale = 0.4f;
-                float otherAxisScale = 0.6f;
-                float minVelocity = 0.2f;
-                Side side = hit.side;
-                if (side == Side.TOP && (Math.abs(yd) < 0.25f || velocity < minVelocity))
-                {
-                    yd = 0f;
-                    y = hit.y + 1f + 0.25f;
-                    xd = 0f;
-                    zd = 0f;
-                    return;
-                }
-                if (side.getAxis() == Axis.Y)
-                {
-                    yd = -yd * bounceAxisScale;
-                    xd *= otherAxisScale;
-                    zd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
-                }
-                if (side.getAxis() == Axis.X)
-                {
-                    xd = -xd * bounceAxisScale;
-                    yd *= otherAxisScale;
-                    zd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
-                }
-                if (side.getAxis() == Axis.Z)
-                {
-                    zd = -zd * bounceAxisScale;
-                    xd *= otherAxisScale;
-                    yd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
-                }
-            }
-        }
-
-        // Check for entity collision
-        List<Entity> collidingEntities = world.getEntitiesWithinAABBExcludingEntity(this, this.bb.getOffsetBoundingBox(xd, yd, zd));
-        if ((collidingEntities != null && collidingEntities.size() > 0) || fuse <= 0)
-        {
-            if (!((collidingEntities != null && collidingEntities.size() == 1) && collidingEntities.get(0) == owner && tickCount < 4))
-            {
-                world.newExplosion(owner, x, y, z, 1.5F, false, true);
-                remove();
-                return;
-            }
-        }
-
-        // Update position
-        x += xd;
-        y += yd;
-        z += zd;
-
-        float velocityHorizontal = MathHelper.sqrt_double(xd * xd + zd * zd);
-        yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-        for(xRot = (float)((Math.atan2(yd, velocityHorizontal) * 180D) / Math.PI); xRot - xRotO < -180F; xRotO -= 360F) { }
-        for(; xRot - xRotO >= 180F; xRotO += 360F) { }
-        for(; yRot - yRotO < -180F; yRotO -= 360F) { }
-        for(; yRot - yRotO >= 180F; yRotO += 360F) { }
-        xRot = xRotO + (xRot - xRotO) * 0.2F;
-        yRot = yRotO + (yRot - yRotO) * 0.2F;
-        float deceleration = 0.99F;
-        float gravity = 0.06F;
-        if(isInWater())
-        {
-            for(int i = 0; i < 4; i++)
-            {
-                double particleDistance = 0.25D;
-                world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
-            }
-
-            deceleration = 0.8F;
-        }
-        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
-        xd *= deceleration;
-        yd *= deceleration;
-        zd *= deceleration;
-        yd -= gravity;
-        setPos(x, y, z);
-        fuse--;
-    }
-}
+package net.minecraft.core.entity.projectile;
+
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class CannonballBouncyProjectile extends CannonballProjectile
+{
+    private int fuse = 50;
+
+    public CannonballBouncyProjectile(World world, Mob owner)
+    {
+        super(world, owner);
+        x += xd;
+        y += yd;
+        z += zd;
+        setHeading(xd, yd, zd, 0.75F, 0.0F);
+        this.defaultGravity = 0.06f;
+    }
+
+    public CannonballBouncyProjectile(World world, double x, double y, double z)
+    {
+        super(world, x, y, z);
+        this.defaultGravity = 0.06f;
+    }
+
+    @Override
+    public void tick()
+    {
+        baseTick();
+        if(xRotO == 0.0F && yRotO == 0.0F)
+        {
+            float f = MathHelper.sqrt(xd * xd + zd * zd);
+            yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
+            xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
+        }
+
+        float velocity = MathHelper.sqrt(xd * xd + yd * yd + zd * zd);
+
+        // Check for block collision
+        Vec3 currentPos = Vec3.getTempVec3(x, y, z);
+        Vec3 nextPos = Vec3.getTempVec3(x + xd, y + yd - 0.25f, z + zd);
+        HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true);
+        if(hit != null)
+        {
+            if (hit.hitType == HitResult.HitType.TILE)
+            {
+                float bounceAxisScale = 0.4f;
+                float otherAxisScale = 0.6f;
+                float minVelocity = 0.2f;
+                Side side = hit.side;
+                if (side == Side.TOP && (Math.abs(yd) < 0.25f || velocity < minVelocity))
+                {
+                    yd = 0f;
+                    y = hit.y + 1f + 0.25f;
+                    xd = 0f;
+                    zd = 0f;
+                    return;
+                }
+                if (side.getAxis() == Axis.Y)
+                {
+                    yd = -yd * bounceAxisScale;
+                    xd *= otherAxisScale;
+                    zd *= otherAxisScale;
+                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                }
+                if (side.getAxis() == Axis.X)
+                {
+                    xd = -xd * bounceAxisScale;
+                    yd *= otherAxisScale;
+                    zd *= otherAxisScale;
+                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                }
+                if (side.getAxis() == Axis.Z)
+                {
+                    zd = -zd * bounceAxisScale;
+                    xd *= otherAxisScale;
+                    yd *= otherAxisScale;
+                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                }
+            }
+        }
+
+        // Check for entity collision
+        List<Entity> collidingEntities = world.getEntitiesWithinAABBExcludingEntity(this, this.bb.cloneMove(xd, yd, zd));
+        if ((collidingEntities != null && collidingEntities.size() > 0) || fuse <= 0)
+        {
+            if (!((collidingEntities != null && collidingEntities.size() == 1) && collidingEntities.get(0) == owner && tickCount < 4))
+            {
+                world.newExplosion(owner, x, y, z, 1.5F, false, true);
+                remove();
+                return;
+            }
+        }
+
+        // Update position
+        x += xd;
+        y += yd;
+        z += zd;
+
+        float velocityHorizontal = MathHelper.sqrt(xd * xd + zd * zd);
+        yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
+        for(xRot = (float)((Math.atan2(yd, velocityHorizontal) * 180D) / Math.PI); xRot - xRotO < -180F; xRotO -= 360F) { }
+        for(; xRot - xRotO >= 180F; xRotO += 360F) { }
+        for(; yRot - yRotO < -180F; yRotO -= 360F) { }
+        for(; yRot - yRotO >= 180F; yRotO += 360F) { }
+        xRot = xRotO + (xRot - xRotO) * 0.2F;
+        yRot = yRotO + (yRot - yRotO) * 0.2F;
+        float deceleration = 0.99F;
+        float gravity = 0.06F;
+        if(isInWater())
+        {
+            for(int i = 0; i < 4; i++)
+            {
+                double particleDistance = 0.25D;
+                world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
+            }
+
+            deceleration = 0.8F;
+        }
+        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
+        xd *= deceleration;
+        yd *= deceleration;
+        zd *= deceleration;
+        yd -= gravity;
+        setPos(x, y, z);
+        fuse--;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java b/src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java
similarity index 67%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
rename to src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java
index d0db26ae8..c0438a8a5 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.entity.projectile;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.world.World;
 
-public class EntityCannonball extends EntityProjectile
+public class CannonballProjectile extends Projectile
 {
 
-    public EntityCannonball(World world)
+    public CannonballProjectile(World world)
     {
         super(world);
     }
-    
-    public EntityCannonball(World world, double x, double y, double z)
+
+    public CannonballProjectile(World world, Mob owner)
     {
-        super(world, x, y, z);
+        super(world, owner);
     }
-    
-    public EntityCannonball(World world, EntityLiving owner)
+
+    public CannonballProjectile(World world, double x, double y, double z)
     {
-        super(world, owner);
+        super(world, x, y, z);
     }
     @Override
-    public void init(){
+    public void initProjectile(){
         this.defaultGravity = 0.09f;
         this.defaultProjectileSpeed = 0.88f;
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java
new file mode 100644
index 000000000..4aba7d342
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.entity.projectile;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.ChickenMob;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.world.World;
+
+public class EggProjectile extends Projectile
+{
+
+    public EggProjectile(World world)
+    {
+        super(world);
+        this.modelItem = Items.EGG_CHICKEN;
+    }
+
+    public EggProjectile(World world, Mob owner)
+    {
+        super(world, owner);
+        this.modelItem = Items.EGG_CHICKEN;
+    }
+
+    public EggProjectile(World world, double x, double y, double z)
+    {
+        super(world, x, y, z);
+        this.modelItem = Items.EGG_CHICKEN;
+    }
+
+    @Override
+    public void onHit(HitResult hitResult){
+        if(!world.isClientSide && random.nextInt(8) == 0)
+        {
+            byte byte0 = 1;
+            if(random.nextInt(32) == 0)
+            {
+                byte0 = 4;
+            }
+            for(int k = 0; k < byte0; k++)
+            {
+                ChickenMob entitychicken = new ChickenMob(world);
+                entitychicken.moveTo(x, y, z, yRot, 0.0F);
+                world.entityJoinedWorld(entitychicken);
+            }
+
+        }
+        super.onHit(hitResult);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
similarity index 63%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
rename to src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
index a23db3386..940c52802 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
@@ -1,28 +1,32 @@
 package net.minecraft.core.entity.projectile;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.monster.EntityGhast;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.monster.GhastMob;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, AxisAlignedBB, MathHelper, EntityLiving, 
+//            Entity, AxisAlignedBB, MathHelper, Mob,
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound
 
-public class EntityFireball extends EntityProjectile
+public class FireballProjectile extends Projectile
 {
+    public double xPower = 0;
+    public double yPower = 0;
+    public double zPower = 0;
 
-    public EntityFireball(World world)
+    public FireballProjectile(World world)
     {
         super(world);
         setSize(1.0F, 1.0F);
     }
-    public EntityFireball(World world, double x, double y, double z,
-            double vX, double vY, double vZ)
+
+    public FireballProjectile(World world, double x, double y, double z,
+                              double vX, double vY, double vZ)
     {
         super(world);
         setSize(1.0F, 1.0F);
@@ -31,12 +35,11 @@ public class EntityFireball extends EntityProjectile
         xd = yd = zd = 0.0D;
         setAccel(vX, vY, vZ);
     }
-
-    public EntityFireball(World world, EntityLiving entityliving, double vX, double vY, double vZ)
+    public FireballProjectile(World world, Mob owner, double vX, double vY, double vZ)
     {
         super(world);
         setSize(1.0F, 1.0F);
-        moveTo(entityliving.x, entityliving.y, entityliving.z, entityliving.yRot, entityliving.xRot);
+        moveTo(owner.x, owner.y, owner.z, owner.yRot, owner.xRot);
         setPos(x, y, z);
         heightOffset = 0.0F;
         xd = yd = zd = 0.0D;
@@ -46,25 +49,25 @@ public class EntityFireball extends EntityProjectile
         setAccel(vX, vY, vZ);
     }
     private void setAccel(double vX, double vY, double vZ){
-        double velocity = MathHelper.sqrt_double(vX * vX + vY * vY + vZ * vZ);
+        double velocity = MathHelper.sqrt(vX * vX + vY * vY + vZ * vZ);
         if (velocity != 0){
-            accelX = (vX / velocity) * 0.1D;
-            accelY = (vY / velocity) * 0.1D;
-            accelZ = (vZ / velocity) * 0.1D;
+            xPower = (vX / velocity) * 0.1D;
+            yPower = (vY / velocity) * 0.1D;
+            zPower = (vZ / velocity) * 0.1D;
         } else {
-            accelX = 0;
-            accelY = 0;
-            accelZ = 0;
+            xPower = 0;
+            yPower = 0;
+            zPower = 0;
         }
     }
+
     @Override
-    protected void init()
+    protected void initProjectile()
     {
         damage = 0;
         defaultGravity = 0.00f;
         defaultProjectileSpeed = 1f;
     }
-
     @Override
 	public void tick()
     {
@@ -79,7 +82,7 @@ public class EntityFireball extends EntityProjectile
             {
                 if(result.entity != null)
                 {
-                    if (result.entity instanceof EntityGhast){
+                    if (result.entity instanceof GhastMob){
                         result.entity.hurt(owner, 5, DamageType.COMBAT);
                     } else {
                         result.entity.hurt(owner, damage, DamageType.COMBAT);
@@ -92,11 +95,12 @@ public class EntityFireball extends EntityProjectile
     }
     public void afterTick(){
         super.afterTick();
-        xd += accelX;
-        yd += accelY;
-        zd += accelZ;
+        xd += xPower;
+        yd += yPower;
+        zd += zPower;
         world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
     }
+
     @Override
 	public boolean isPickable()
     {
@@ -108,25 +112,24 @@ public class EntityFireball extends EntityProjectile
     {
         return 1.0F;
     }
-
     @Override
     public boolean hurt(Entity entity, int i, DamageType type)
     {
         markHurt();
         if(entity != null)
         {
-            Vec3d vec3d = entity.getLookAngle();
-            if (entity instanceof EntityLiving){
-                this.owner = (EntityLiving) entity;
+            Vec3 lookAngle = entity.getLookAngle();
+            if (entity instanceof Mob){
+                this.owner = (Mob) entity;
             }
-            if(vec3d != null)
+            if(lookAngle != null)
             {
-                xd = vec3d.xCoord;
-                yd = vec3d.yCoord;
-                zd = vec3d.zCoord;
-                accelX = xd * 0.1D;
-                accelY = yd * 0.1D;
-                accelZ = zd * 0.1D;
+                xd = lookAngle.x;
+                yd = lookAngle.y;
+                zd = lookAngle.z;
+                xPower = xd * 0.1D;
+                yPower = yd * 0.1D;
+                zPower = zd * 0.1D;
             }
             return true;
         } else
@@ -141,7 +144,4 @@ public class EntityFireball extends EntityProjectile
         this.yd = yd;
         this.zd = zd;
     }
-    public double accelX = 0;
-    public double accelY = 0;
-    public double accelZ = 0;
 }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityPebble.java b/src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java
similarity index 62%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityPebble.java
rename to src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java
index 6c61d43da..8ea779de1 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityPebble.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java
@@ -1,39 +1,39 @@
 package net.minecraft.core.entity.projectile;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, AxisAlignedBB, EntityLiving, MathHelper, 
+//            Entity, AxisAlignedBB, Mob, MathHelper,
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound, 
-//            EntityPlayer, ItemStack, Item, InventoryPlayer
+//            Player, ItemStack, Item, InventoryPlayer
 
-public class EntityPebble extends EntityProjectile
+public class PebbleProjectile extends Projectile
 {
     private boolean firstBounce = true;
 
-    public EntityPebble(World world)
+    public PebbleProjectile(World world)
     {
         super(world);
     }
 
-    public EntityPebble(World world, EntityLiving entityliving)
+    public PebbleProjectile(World world, Mob owner)
     {
-        super(world, entityliving);
+        super(world, owner);
     }
 
-    public EntityPebble(World world, double d, double d1, double d2)
+    public PebbleProjectile(World world, double x, double y, double z)
     {
-        super(world, d, d1, d2);
+        super(world, x, y, z);
     }
     @Override
-    public void init(){
-        super.init();
+    public void initProjectile(){
+        super.initProjectile();
         this.damage = 1;
     }
     @Override
@@ -45,7 +45,7 @@ public class EntityPebble extends EntityProjectile
 
         if(!world.isClientSide)
         {
-            EntityItem item = new EntityItem(world, x, y, z, new ItemStack(Item.ammoPebble, 1));
+            ItemEntity item = new ItemEntity(world, x, y, z, new ItemStack(Items.AMMO_PEBBLE, 1));
             world.entityJoinedWorld(item);
         }
 
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
similarity index 80%
rename from src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/Projectile.java
index be5cb3aee..6c3e178ef 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.entity.projectile;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
 import java.util.List;
 
-public class EntityProjectile extends Entity {
-    public EntityLiving owner;
+public class Projectile extends Entity {
+    public Mob owner;
     protected int ticksInGround;
     protected int ticksInAir;
     public int damage;
@@ -23,13 +23,16 @@ public class EntityProjectile extends Entity {
     protected float gravity;
     protected float defaultProjectileSpeed;
     protected float projectileSpeed;
-    public EntityProjectile(World world)
+    public Projectile(World world)
     {
         super(world);
         ticksInAir = 0;
         setSize(0.25F, 0.25F);
+
+        initProjectile();
     }
-    public EntityProjectile(World world, EntityLiving owner)
+
+    public Projectile(World world, Mob owner)
     {
         super(world);
         ticksInAir = 0;
@@ -46,9 +49,11 @@ public class EntityProjectile extends Entity {
         zd = MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
         yd = -MathHelper.sin((xRot / 180F) * MathHelper.PI) * f;
         setHeading(xd, yd, zd, 1.5F, 1.0F);
+
+        initProjectile();
     }
 
-    public EntityProjectile(World world, double x, double y, double z)
+    public Projectile(World world, double x, double y, double z)
     {
         super(world);
         ticksInAir = 0;
@@ -56,11 +61,15 @@ public class EntityProjectile extends Entity {
         setSize(0.25F, 0.25F);
         setPos(x, y, z);
         heightOffset = 0.0F;
+
+        initProjectile();
     }
 
     @Override
-    protected void init()
-    {
+    protected void defineSynchedData() {
+
+    }
+    protected void initProjectile(){
         damage = 0;
         defaultGravity = 0.03f;
         defaultProjectileSpeed = 0.99f;
@@ -69,7 +78,7 @@ public class EntityProjectile extends Entity {
     @Override
     public boolean shouldRenderAtSqrDistance(double distance)
     {
-        double d1 = bb.getAverageEdgeLength() * 4D;
+        double d1 = bb.getSize() * 4D;
         d1 *= 64D;
         return distance < d1 * d1;
     }
@@ -86,7 +95,7 @@ public class EntityProjectile extends Entity {
 
     public void setHeading(double newMotionX, double newMotionY, double newMotionZ, float speed, float randomness)
     {
-        float velocity = MathHelper.sqrt_double(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
+        float velocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
         newMotionX /= velocity;
         newMotionY /= velocity;
         newMotionZ /= velocity;
@@ -99,7 +108,7 @@ public class EntityProjectile extends Entity {
         xd = newMotionX;
         yd = newMotionY;
         zd = newMotionZ;
-        float f3 = MathHelper.sqrt_double(newMotionX * newMotionX + newMotionZ * newMotionZ);
+        float f3 = MathHelper.sqrt(newMotionX * newMotionX + newMotionZ * newMotionZ);
         yRotO = yRot = (float)((java.lang.Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
         xRotO = xRot = (float)((java.lang.Math.atan2(newMotionY, f3) * 180D) / Math.PI);
         ticksInGround = 0;
@@ -107,7 +116,7 @@ public class EntityProjectile extends Entity {
 
     public void setHeadingPrecise(double newMotionX, double newMotionY, double newMotionZ, float speed)
     {
-        float velocity = MathHelper.sqrt_double(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
+        float velocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
         newMotionX /= velocity;
         newMotionY /= velocity;
         newMotionZ /= velocity;
@@ -117,7 +126,7 @@ public class EntityProjectile extends Entity {
         xd = newMotionX;
         yd = newMotionY;
         zd = newMotionZ;
-        float horizontalVelocity = MathHelper.sqrt_double(newMotionX * newMotionX + newMotionZ * newMotionZ);
+        float horizontalVelocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionZ * newMotionZ);
         yRotO = yRot = (float)((Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
         xRotO = xRot = (float)((Math.atan2(newMotionY, horizontalVelocity) * 180D) / Math.PI);
         ticksInGround = 0;
@@ -132,7 +141,7 @@ public class EntityProjectile extends Entity {
         this.zd = zd;
         if(xRotO == 0.0F && yRotO == 0.0F)
         {
-            float f = MathHelper.sqrt_double(xd * xd + zd * zd);
+            float f = MathHelper.sqrt(xd * xd + zd * zd);
             yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
             xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
         }
@@ -147,24 +156,24 @@ public class EntityProjectile extends Entity {
         ticksInAir++;
 
         HitResult movingobjectposition = getHitResult();
-        Vec3d oldPosition = Vec3d.createVector(x, y, z);
-        Vec3d newPosition = Vec3d.createVector(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
+        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
         if(movingobjectposition != null)
         {
-            newPosition = Vec3d.createVector(movingobjectposition.location.xCoord, movingobjectposition.location.yCoord, movingobjectposition.location.zCoord);
+            newPosition = Vec3.getTempVec3(movingobjectposition.location.x, movingobjectposition.location.y, movingobjectposition.location.z);
         }
         if(!world.isClientSide)
         {
             Entity entity = null;
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.addCoord(xd, yd, zd).expand(1.0D, 1.0D, 1.0D));
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(xd, yd, zd).grow(1.0D, 1.0D, 1.0D));
             double d = 0.0D;
             for (Entity entity1 : list) {
                 if (!entity1.isPickable() || entity1 == owner && ticksInAir < 5) {
                     continue;
                 }
                 float f4 = 0.3F;
-                AABB axisalignedbb = entity1.bb.expand(f4, f4, f4);
-                HitResult movingobjectposition1 = axisalignedbb.func_1169_a(oldPosition, newPosition);
+                AABB axisalignedbb = entity1.bb.grow(f4, f4, f4);
+                HitResult movingobjectposition1 = axisalignedbb.clip(oldPosition, newPosition);
                 if (movingobjectposition1 == null) {
                     continue;
                 }
@@ -187,8 +196,8 @@ public class EntityProjectile extends Entity {
         afterTick();
     }
     public HitResult getHitResult(){
-        Vec3d oldPosition = Vec3d.createVector(x, y, z);
-        Vec3d newPosition = Vec3d.createVector(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
+        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
         return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition);
     }
     public void onHit(HitResult hitResult){
@@ -208,7 +217,7 @@ public class EntityProjectile extends Entity {
         x += xd;
         y += yd;
         z += zd;
-        float f = MathHelper.sqrt_double(xd * xd + zd * zd);
+        float f = MathHelper.sqrt(xd * xd + zd * zd);
         yRot = (float)((java.lang.Math.atan2(xd, zd) * 180D) / Math.PI);
         xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
         while (xRot - xRotO < -180F) {
